/*
*	Oku Mod v1.4
*	Copyright  2014 by JDM
*
*	Gncellemeler:
*			- v1.0 = Plugin Balang
*			- v1.1 = Modeller Kaldrld
*			- v1.2 = Rendering(Glow) bug fixlendi
*			- v1.3 = Xp verme/alma fixlendi
*			- v1.4 = Ok & Level sistemi dzenlendi.
*/

#include <amxmodx>
#include <amxmisc>
#include <engine>
#include <hamsandwich>
#include <nvault>  
#include <csx> 
#include <xs>
#include <fakemeta>
#include <fm_cstrike>
#include <colorchat>

#define PLUGIN "MOD: Okcu Mod"
#define VERSION "1.4"
#define AUTHOR "JDM"

#define MAXLEVELS 10

new	g_exp[33],
	g_level[33],
	g_vault,
	cvar_xp_bow,
	cvar_xp_knife,
	cvar_reklam,
	SaveXP,
	cvar_nickdegistirme_engel,
	OyuncuListesi[128][32],
	ToplamSatir,
	IsUserList[33] = 0,
	tag[]= "^4[Okcu Mod]:^1",
	Symbols[20],
	Min, 
	Max,
	g_on = 0
const TASK_CLEAR = 258
new const LEVELS[MAXLEVELS] = {
	100, // Level 1
	500, // Level 2
	1000, // Level 3
	2000, // Level 4
	5000, // Level 5
	10000, // Level 6
	30000, // Level 7
	50000, // Level 8
	70000, // Level 9
	100000 // Level 10
};
new const OK1P[] = "models/okcumod/p_level1.mdl"
new const OK1V[] = "models/okcumod/v_level1.mdl"
new const OK1W[] = "models/okcumod/w_level1.mdl"
new const OK2P[] = "models/okcumod/p_level2.mdl"
new const OK2V[] = "models/okcumod/v_level2.mdl"
new const OK2W[] = "models/okcumod/w_level2.mdl"
new const OK3P[] = "models/okcumod/p_level3.mdl"
new const OK3V[] = "models/okcumod/v_level3.mdl"
new const OK3W[] = "models/okcumod/w_level3.mdl"
new const OK4P[] = "models/okcumod/p_level4.mdl"
new const OK4V[] = "models/okcumod/v_level4.mdl"
new const OK4W[] = "models/okcumod/w_level4.mdl"
new const ARROW_MODEL[] = "models/arrow.mdl"

#define BURN_CLASSNAME "flame"
#define BURN_MODEL "sprites/flame_burn01.spr"
#define POISON_MODEL "sprites/poison.spr"
#define BASE_SPEED 1200
#define BONUS_SPEED 600
#define BURN_LIFE 10.0
#define BURN_PERIOD 2.0
#define BURN_DAMAGE 10.0
#define POISON_TIME 5.0
#define POISON_PERIOD 1.0
#define POISON_DAMAGE 5.0
#define SPEED_LOW_POISON 0.8
#define SLOW_POISON_TIME 3.0
#define NORMAL_DMG 45.0
#define SPEED_LOW_ICE 0.5
#define SLOW_ICE_TIME 7.0
#define EXPLODE_DAMAGE 90.0
#define EXPLODE_HITRADIUS 400
#define NORMAL_AMMO 250
#define FIRE_AMMO 250
#define ICE_AMMO 250
#define POISON_AMMO 250
#define EXPLODE_AMMO 250
#define NEXT_SHOT_TIME 0.97
#define fm_remove_entity(%1) engfunc(EngFunc_RemoveEntity, %1)
#define fm_create_entity(%1) engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, %1))
#define fm_entity_set_model(%1,%2) engfunc(EngFunc_SetModel, %1, %2)

new const ARROW_SHOOT[] = "oksesi.wav"
new const LEVEL_UP[] = "lvup.wav"
new const WON_XP[] = "wonxp.wav"
new g_exp_sprid
new Float:g_start_time[33], Float:g_finish_time[33]
new Float:g_Burn[33], Float:g_Poisoned[33]
new g_slowed[33], g_pressed[33], Float:g_old_speed[33]
new g_ammo[33], g_normal_ammo[33], g_fire_ammo[33], g_ice_ammo[33], g_poison_ammo[33], g_explode_ammo[33]
new bool:draw_wpn[33]
new g_HasBow[33]
new g_bow_mode[33], g_dmg_mode[33]
new g_MaxPlayers, syncObj
new g_FrozenRenderingFx[33]
new Float:g_FrozenRenderingColor[33][3]
new g_FrozenRenderingRender[33]
new katil[33]
new Float:g_FrozenRenderingAmount[33]
new g_MsgDamage, g_msgBarTime
enum {
	anim_idle,
	anim_shot1,
	anim_shot2,
	anim_reload,
	anim_draw
};
enum {
	NORMAL_MODE = 1,
	FIRE_MODE = 2,
	ICE_MODE = 3,
	POISON_MODE = 4,
	EXPLODE_MODE = 5
};
enum {
	dmg_fire = 1,
	dmg_poison = 2
};
public plugin_precache() {	
	new Entity = create_entity("info_map_parameters");
	DispatchKeyValue(Entity, "buying", "3");
	DispatchSpawn(Entity);

	precache_model(OK1P)
	precache_model(OK1V)
	precache_model(OK1W)
	precache_model(OK2P)
	precache_model(OK2V)
	precache_model(OK2W)
	precache_model(OK3P)
	precache_model(OK3V)
	precache_model(OK3W)
	precache_model(OK4P)
	precache_model(OK4V)
	precache_model(OK4W)
	precache_model(ARROW_MODEL)
	precache_model(BURN_MODEL)
	precache_model(POISON_MODEL)

	precache_sound(ARROW_SHOOT)
	precache_sound(LEVEL_UP)
	precache_sound(WON_XP)
	precache_sound("weapons/357_cock1.wav")

	g_exp_sprid = engfunc(EngFunc_PrecacheModel, "sprites/zerogxplode.spr")

	new szDirectory[256], szMapName[32];
	get_configsdir(szDirectory, charsmax(szDirectory));
	get_mapname(szMapName, charsmax(szMapName));
	format(szDirectory, charsmax(szDirectory), "%s/sounds/%s.ini", szDirectory, szMapName);
	server_cmd("sv_skyname forest");
}
public plugin_init() {
	register_plugin(PLUGIN, VERSION, AUTHOR)

	register_concmd("amx_xpver" ,"CmdGiveXp",ADMIN_RCON,"<isim> <miktar>")
	register_concmd("amx_xpal", "CmdTakeXp",ADMIN_RCON,"<isim> <miktar>")

	RegisterHam(Ham_Spawn, "player", "OyuncuDogunca", 1)
	RegisterHam(Ham_Killed, "player", "OyuncuOlunce")
	RegisterHam(Ham_Weapon_PrimaryAttack, "weapon_scout", "fw_bow_PrimaryAttack")
	RegisterHam(Ham_Weapon_SecondaryAttack, "weapon_scout", "fw_bow_SecondaryAttack")
	RegisterHam(Ham_Weapon_Reload, "weapon_scout", "fw_bow_Reload")
	RegisterHam(Ham_Item_Deploy, "weapon_scout", "fw_bow_Deploy_Post", 1)

	register_think(BURN_CLASSNAME, "BurnThink")

	register_event("DeathMsg", "eDeathMsg", "a")
	register_event("ResetHUD", "onResetHUD", "b");
	register_event("CurWeapon", "Event_CurrentWeapon", "be", "1=1")
	register_event("HLTV", "YeniTur", "a", "1=0", "2=0")

	register_logevent("eRoundEnd",2,"1=Round_End")

	register_forward(FM_ClientUserInfoChanged, "fwClientUserInfoChanged")
	register_forward(FM_CmdStart, "fw_CmdStart")
	register_forward(FM_UpdateClientData, "fw_UpdateClientData_Post", 1)
	register_forward(FM_Touch, "fw_touch")

	register_message(get_user_msgid("HideWeapon"), "ParaGizle")

	cvar_xp_bow=register_cvar("cvar_xp_bow","15")
	cvar_xp_knife=register_cvar("cvar_xp_knife","5")
	SaveXP = register_cvar("SaveXP", "1")
	cvar_reklam=register_cvar("xp_cvar_reklam" ,"1")
	cvar_nickdegistirme_engel=register_cvar("name_change","1") // sim deitirme engeli 1 = Aar / 0 = Kapatr

	g_vault = nvault_open("OkcuXP")

	register_clcmd("say","Participate")
	register_clcmd("say_team","Participate")
	register_clcmd("drop","dropcmd")

	g_MsgDamage = get_user_msgid("Damage")
	g_msgBarTime = get_user_msgid("BarTime");

	Min=register_cvar("xp_contest_min_xp","500")
	Max=register_cvar("xp_contest_max_xpx","5000")

	g_MaxPlayers = get_maxplayers()
	syncObj = CreateHudSyncObj()
}
public client_connect(id) {
	if(!player_in_list(id)) {
		IsUserList[id] = 0
		return PLUGIN_HANDLED
	}
	IsUserList[id] = 1
	g_HasBow[id] = false
	g_finish_time[id] = 0.0
	return PLUGIN_HANDLED
}
public client_putinserver(id) {
	if(get_pcvar_num(SaveXP) == 1) {
		LoadData(id)
	}
	set_task(10.0,"ClientMsg",id)
	set_task(1.0,"showhudmsj", _, _, _, "b")
	katil[id]=0
}
public client_disconnect(id) {
	if(get_pcvar_num(SaveXP) == 1) {
		SaveData(id)
		g_exp[id] = 0
		g_level[id] = 0
	}
	katil[id] = 0
	new oyuncular[32], oyunculistesi,ceset;
	get_players(oyuncular, oyunculistesi,"b");

	new isim[32];
	get_user_name(id, isim, 31);
	for(new op;op<oyunculistesi;op++ ){
		ceset=oyuncular[op]
		if(katil[ceset]==id) {
			ExecuteHamB(Ham_CS_RoundRespawn, ceset)
			katil[ceset]=0
			ColorChat(ceset,NORMAL,"%s ^4%s^1 oyundan ciktigi icin yeniden dogdun.",tag, isim)
		}
	}
}
public onResetHUD(id) {
	message_begin(MSG_ONE, get_user_msgid("HideWeapon"), _, id);
	write_byte((1<<5));
	message_end( );
}
public eRoundEnd() {
	remove_bow()
}
public ParaGizle( ) {
	set_msg_arg_int(1, ARG_BYTE, get_msg_arg_int(1) | (1<<5));
}
public showhudmsj() { 
	for(new i = 1; i <= g_MaxPlayers; i++) {
		if(is_user_alive(i) && is_user_connected(i)) {
			set_hudmessage(0, 255, 0, -1.0, 0.9, 0, 6.0, 12.0) 
			ShowSyncHudMsg(i,syncObj, "[ Level: %i | Xp: %i/%i ]", g_level[i], g_exp[i], LEVELS[g_level[i]])
		}
	}
}
public fwClientUserInfoChanged(id,buffer) {
	if (!is_user_connected(id) || get_pcvar_num(cvar_nickdegistirme_engel) == 0) {
		return FMRES_IGNORED
	}

	static val[32]
	static name[32]
	get_user_name(id, name, 31)
	engfunc(EngFunc_InfoKeyValue, buffer, "name", val, sizeof val- 1)
	
	if(equal(val, name)) {
		return FMRES_IGNORED
	}
	engfunc(EngFunc_SetClientKeyValue, id, buffer, "name", name)
	
	console_print(id,"Isim Degistirme Bu Sunucuda Engellenmistir...")
	return PLUGIN_HANDLED
}
public ClientMsg(id) { 
	new name[32]
	get_user_name(id,name,31)
	if(get_pcvar_num(cvar_reklam) == 1) {
		ColorChat(id,NORMAL,"%s Sunucumuza Hosgeldiniz Sayin ^4%s.^1",tag, name)
	}
}
public YeniTur() {
	new players[32],inum,id
	get_players(players,inum)
	for(new i = 0; i < g_MaxPlayers; i++) {
		id = players[i]
		fm_set_rendering(id,_,0,0,0,_,0); 
		g_Poisoned[id] = 0.0
		g_Burn[id] = 0.0
		g_slowed[id] = false
	}
}
public dropcmd(id) {
	if(g_HasBow[id] && get_user_weapon(id) == CSW_SCOUT) {
		new Float:Aim[3],Float:origin[3]
		VelocityByAim(id, 64, Aim)
		entity_get_vector(id,EV_VEC_origin,origin)
		
		origin[0] += Aim[0]
		origin[1] += Aim[1]
		
		new bow = create_entity("info_target")
		entity_set_string(bow,EV_SZ_classname,"bow")
		entity_set_model(bow,OK1W)
		
		entity_set_size(bow,Float:{-2.0,-2.0,-2.0},Float:{5.0,5.0,5.0})
		entity_set_int(bow,EV_INT_solid,1)
		
		entity_set_int(bow,EV_INT_movetype,6)
		entity_set_vector(bow,EV_VEC_origin,origin)
		g_HasBow[id] = false
		remowegun(id)
		return PLUGIN_HANDLED
	} 
	return PLUGIN_CONTINUE
}
public remowegun(id) { 
	new wpnList[32]
	new number
	get_user_weapons(id,wpnList,number)
	for (new i = 0;i < number ;i++) { 
		if (wpnList[i] == CSW_SCOUT) {
			fm_strip_user_gun(id, wpnList[i])
		}
	}
}
public playanim(player,anim) {
	set_pev(player, pev_weaponanim, anim)
	message_begin(MSG_ONE, SVC_WEAPONANIM, {0, 0, 0}, player)
	write_byte(anim)
	write_byte(pev(player, pev_body))
	message_end()
}
public Event_CurrentWeapon(id) {
	if(is_user_bot(id) && !is_user_connected(id)) return;
	
	new weaponID = read_data(2)
	
	if(weaponID == CSW_SCOUT) {
		if(g_HasBow[id]) {
			if(!draw_wpn[id]) {
				if(g_level[id] == 1) {
					playanim(id, anim_draw)
					update_ammo(id)
					entity_set_string(id, EV_SZ_viewmodel, OK1V)
					entity_set_string(id, EV_SZ_weaponmodel, OK1P)
					draw_wpn[id] = true
				} else if(g_level[id] == 2) {
					playanim(id, anim_draw)
					update_ammo(id)
					entity_set_string(id, EV_SZ_viewmodel, OK1V)
					entity_set_string(id, EV_SZ_weaponmodel, OK1P)
					draw_wpn[id] = true
				}
				if(g_level[id] == 3) {
					playanim(id, anim_draw)
					update_ammo(id)
					entity_set_string(id, EV_SZ_viewmodel, OK2V)
					entity_set_string(id, EV_SZ_weaponmodel, OK2P)
					draw_wpn[id] = true
				} else if(g_level[id] == 4) {
					playanim(id, anim_draw)
					update_ammo(id)
					entity_set_string(id, EV_SZ_viewmodel, OK2V)
					entity_set_string(id, EV_SZ_weaponmodel, OK2P)
					draw_wpn[id] = true
				} else if(g_level[id] == 5) {
					playanim(id, anim_draw)
					update_ammo(id)
					entity_set_string(id, EV_SZ_viewmodel, OK3V)
					entity_set_string(id, EV_SZ_weaponmodel, OK3P)
					draw_wpn[id] = true
				} else if(g_level[id] == 6) {
					playanim(id, anim_draw)
					update_ammo(id)
					entity_set_string(id, EV_SZ_viewmodel, OK3V)
					entity_set_string(id, EV_SZ_weaponmodel, OK3P)
					draw_wpn[id] = true
				} else if(g_level[id] == 7) {
					playanim(id, anim_draw)
					update_ammo(id)
					entity_set_string(id, EV_SZ_viewmodel, OK4V)
					entity_set_string(id, EV_SZ_weaponmodel, OK4P)
					draw_wpn[id] = true
				} else if(g_level[id] == 8) {
					playanim(id, anim_draw)
					update_ammo(id)
					entity_set_string(id, EV_SZ_viewmodel, OK4V)
					entity_set_string(id, EV_SZ_weaponmodel, OK4P)
					draw_wpn[id] = true
				} else if(g_level[id] == 9) {
					playanim(id, anim_draw)
					update_ammo(id)
					entity_set_string(id, EV_SZ_viewmodel, OK4V)
					entity_set_string(id, EV_SZ_weaponmodel, OK4P)
					draw_wpn[id] = true
				} else if(g_level[id] == 10) {
					playanim(id, anim_draw)
					update_ammo(id)
					entity_set_string(id, EV_SZ_viewmodel, OK4V)
					entity_set_string(id, EV_SZ_weaponmodel, OK4P)
					draw_wpn[id] = true
				}
			}
		}
	} else {
		draw_wpn[id] = false;
	}
}
public CmdGiveXp(id, level,cid) {
	if(!cmd_access(id, level, cid, 3))
		return PLUGIN_HANDLED;
	
	new target[32], amount[21], reason[21];
	
	read_argv(1, target, 31);
	read_argv(2, amount, 20);
	read_argv(3, reason, 20);
	
	new player = cmd_target(id, target, 8);
	
	if(!player) 
		return PLUGIN_HANDLED;
	
	new admin_name[32], player_name[32];
	get_user_name(id, admin_name, 31);
	get_user_name(player, player_name, 31);
	
	new expnum = str_to_num(amount);
	
	g_exp[player] += expnum;
	
	switch(get_cvar_num("amx_show_activity")) {
		case 1: ColorChat(0, NORMAL, "ADMIN, ^4%s^1'e ^3%i^1 xp verdi.", player_name, expnum);
		case 2: ColorChat(0, NORMAL, "ADMIN ^4%s^1: ^3%s^1'e ^4%i^1 xp verdi.", admin_name, player_name, expnum);
	}
	
	ColorChat(player,NORMAL,"%s Sanlisin, Admin'den ^4%i^1 XP aldin. Toplam Xp: ^4%d^1 oldu.", tag, expnum, g_exp[player]);
	
	SaveData(player)
	
	return PLUGIN_CONTINUE;
}
public CmdTakeXp(id, level,cid) {
	if(!cmd_access(id, level, cid, 3))
		return PLUGIN_HANDLED;
	
	new target[32], amount[21], reason[21];
	
	read_argv(1, target, 31);
	read_argv(2, amount, 20);
	read_argv(3, reason, 20);
	
	new player = cmd_target(id, target, 8);
	
	if(!player) 
		return PLUGIN_HANDLED;
	
	new admin_name[32], player_name[32];
	get_user_name(id, admin_name, 31);
	get_user_name(player, player_name, 31);
	
	new expnum = str_to_num(amount);
	
	g_exp[player] -= expnum;
	
	switch(get_cvar_num("amx_show_activity")) {
		case 1: ColorChat(0, NORMAL, "%s ADMIN: ^4%s^1'den ^3%i^1 xp aldi.", tag, player_name, expnum);
		case 2: ColorChat(0, NORMAL, "%s ADMIN ^4%s^1: ^3%s^1'den ^4%i^1 xp aldi.", tag, admin_name, player_name, expnum);
	}
	
	ColorChat(player,NORMAL,"%s Kotu Sans, Admin senden ^4%i^1 XP geri aldi. Toplam Xp: ^4%d^1 oldu.", tag, expnum, g_exp[player]);
	
	SaveData(player)
	
	return PLUGIN_CONTINUE;
}
public eDeathMsg() {
	new Victim=read_data(2)
	new victim_name[32]
	get_user_name(Victim,victim_name,charsmax(victim_name))
	new weapon, HitPoint, attacker = get_user_attacker(Victim, weapon, HitPoint)
	
	if(weapon== CSW_SCOUT) {
		g_exp[attacker] += get_pcvar_num(cvar_xp_bow)
		ColorChat(attacker, NORMAL, "%s Oyuncu ^4%s^1'i Okla Vurarak Oldurdugun icin ^4%i^1 XP kazandin..",tag, victim_name, get_pcvar_num(cvar_xp_bow))
		emit_sound(attacker, CHAN_WEAPON, WON_XP, VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
	}
	if(weapon== CSW_KNIFE) {
		g_exp[attacker] += get_pcvar_num(cvar_xp_knife)
		ColorChat(attacker, NORMAL, "%s Oyuncu ^4%s^1'i Bicakla Oldurdugun icin ^4%i^1 XP kazandin..",tag, victim_name, get_pcvar_num(cvar_xp_knife))
		emit_sound(attacker, CHAN_WEAPON, WON_XP, VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
	}
	while(g_exp[attacker] >= LEVELS[g_level[attacker]]) {
		ColorChat(attacker, NORMAL, "%s Tebrikler!! ^4Level^1 Atladiniz!!", tag)
		emit_sound(attacker, CHAN_WEAPON, LEVEL_UP, VOL_NORM, ATTN_NORM, 0, PITCH_NORM)
		g_level[attacker] += 1
	}
	SaveData(attacker)
	return PLUGIN_HANDLED
}
public OyuncuDogunca(id) {
	if(!is_user_alive(id)) return;

	katil[id] = 0
	set_task(0.1,"Player_items", id)
	fm_strip_user_weapons(id)
	fm_give_item(id, "weapon_knife")
	fm_set_user_health(id, 250)
}
public cmdMenu(id) {
	new menu, Menuz[512]
	formatex(Menuz, charsmax(Menuz), "\rSkill Secimi:^n\rLevel: \w%d | \rXp: \w%d", g_level[id], g_exp[id])
	menu = menu_create(Menuz, "menu_handler")

	formatex(Menuz, charsmax(Menuz), "%s", g_level[id] >= 1 ? "\wNormal Ok - \w[\rACIK\w]" : "\dGerekli Olan Seviye = \r[1]")
	menu_additem(menu, Menuz, "1", 0)
	formatex(Menuz, charsmax(Menuz), "%s", g_level[id] >= 3 ? "\wAtes Oku - \w[\rACIK\w]" : "\dGerekli Olan Seviye = \r[3]")
	menu_additem(menu, Menuz, "2", 0)
	formatex(Menuz, charsmax(Menuz), "%s", g_level[id] >= 5 ? "\wBuz Oku - \w[\rACIK\w]" : "\dGerekli Olan Seviye = \r[5]")
	menu_additem(menu, Menuz, "3", 0)
	formatex(Menuz, charsmax(Menuz), "%s", g_level[id] >= 7 ? "\wZehir Oku - \w[\rACIK\w]" : "\dGerekli Olan Seviye = \r[7]")
	menu_additem(menu, Menuz, "4", 0)
	formatex(Menuz, charsmax(Menuz), "%s", g_level[id] >= 9 ? "\wPatlayan Ok - \w[\rACIK\w]" : "\dGerekli Olan Seviye = \r[9]")
	menu_additem(menu, Menuz, "5", 0)
	formatex(Menuz, charsmax(Menuz), "\yGeri")
	menu_setprop(menu, MPROP_BACKNAME ,Menuz)
	formatex(Menuz, charsmax(Menuz), "\yIleri")
	menu_setprop(menu,MPROP_NEXTNAME ,Menuz)
	formatex(Menuz, charsmax(Menuz), "\rCikis")
	menu_setprop(menu,MPROP_EXITNAME,Menuz)
	
	menu_setprop(menu,MPROP_EXIT, MEXIT_ALL)
	menu_display(id, menu, 0)
	
	return PLUGIN_HANDLED;
}
public menu_handler(id, menu, item) {
	if(item == MENU_EXIT) {
		menu_destroy(menu)
		return PLUGIN_HANDLED
	}

	new data[6], iName[64], access, callback
	menu_item_getinfo(menu,item,access,data,charsmax(data),iName,charsmax(iName),callback)

	new key = str_to_num(data)

	switch(key) {
		case 1: {
			if(g_level[id] >= 1) {
				g_bow_mode[id] = NORMAL_MODE
				update_ammo(id)
			} else {
				ColorChat(id,NORMAL,"%s Bu Oku Kullanabilmek icin yeterli ^4level^1'e ulasmadiniz.",tag)
			}
		}
		case 2: {
			if(g_level[id] >= 3) {
				g_bow_mode[id] = FIRE_MODE
				update_ammo(id)
			} else {
				ColorChat(id,NORMAL,"%s Bu Oku Kullanabilmek icin yeterli ^4level^1'e ulasmadiniz.",tag)
			}
		}
		case 3: {
			if(g_level[id] >= 5) {
				g_bow_mode[id] = ICE_MODE
				update_ammo(id)
			}  else {
				ColorChat(id,NORMAL,"%s Bu Oku Kullanabilmek icin yeterli ^4level^1'e ulasmadiniz.",tag)
			}
		}
		case 4: {
			if(g_level[id] >= 7) {
				g_bow_mode[id] = POISON_MODE
				update_ammo(id)
			}  else {
				ColorChat(id,NORMAL,"%s Bu Oku Kullanabilmek icin yeterli ^4level^1'e ulasmadiniz.",tag)
			}
		}
		case 5: {
			if(g_level[id] >= 9) {
				g_bow_mode[id] = EXPLODE_MODE
				update_ammo(id)
			}  else {
				ColorChat(id,NORMAL,"%s Bu Oku Kullanabilmek icin yeterli ^4level^1'e ulasmadiniz.",tag)
			}
		}
	}
	return PLUGIN_HANDLED
}
public Player_items(id) {
	if(g_level[id] == 1) {
		ColorChat(id,RED,"Level 1")
		ColorChat(id,GREEN,"Items: Normal Ok.")
		give_bow(id)
	} else if(g_level[id] == 2) {
		ColorChat(id,RED,"Level 2")
		ColorChat(id,GREEN,"Items: Normal Ok.")
		give_bow(id)
	} else if(g_level[id] == 3) {
		ColorChat(id,RED,"Level 3")
		ColorChat(id,GREEN,"Items: Ates Oku.")
		give_bow2(id)
	} else if(g_level[id] == 4) {
		ColorChat(id,RED,"Level 4")
		ColorChat(id,GREEN,"Items: Ates Oku.")
		give_bow2(id)
	} else if(g_level[id] == 5) {
		ColorChat(id,RED,"Level 5")
		ColorChat(id,GREEN,"Items: Buz Oku.")
		give_bow3(id)
	} else if(g_level[id] == 6) {
		ColorChat(id,RED,"Level 6")
		ColorChat(id,GREEN,"Items: Buz Oku.")
		give_bow3(id)
	} else if(g_level[id] == 7) {
		ColorChat(id,RED,"Level 7")
		ColorChat(id,GREEN,"Items: Zehirli Oku.")
		give_bow4(id);
	} else if(g_level[id] == 8) {	
		ColorChat(id,RED,"Level 8");
		ColorChat(id,GREEN,"Items: Zehirli Oku.");
		give_bow4(id)
	} else if(g_level[id] == 9) {
		ColorChat(id,RED,"Level 9.")
		ColorChat(id,GREEN,"Items: Patlayan Ok.")
		give_bow5(id)
	} else if(g_level[id] == 10) {
		ColorChat(id,RED,"Level 10.")
		ColorChat(id,GREEN,"Items: Patlayan Ok.")
		give_bow5(id)
	}
}
public clear_vars() {
	if(task_exists(TASK_CLEAR))
		remove_task(TASK_CLEAR)
	
	Symbols[0] = EOS
	g_on = 0
}
public Participate(id) {
	if(g_on == 1) {
		new Said[192]
		read_args(Said,charsmax(Said))
		remove_quotes(Said)
		trim(Said)
		
		if(equal(Said,Symbols)) {
			new Name[32]
			get_user_name(id,Name,charsmax(Name))

			if((get_pcvar_num(Min)< get_pcvar_num(Max)) && (get_pcvar_num(Max)>0)) {
				new Ammount=random_num( get_pcvar_num(Min),get_pcvar_num(Max))
				ColorChat(0, NORMAL,"%s %s %i XP Kazandi..!!",tag,Name,Ammount)
			}
		}
		
		if(equali(Said, ""))
			return PLUGIN_HANDLED;
		
	}
	return PLUGIN_CONTINUE;
}
public remove_bow() {
	new nextitem = find_ent_by_class(-1, "bow")
	while ((nextitem = find_ent_by_class(-1, "bow")) != 0) {
		remove_entity(nextitem)
	}
	return PLUGIN_CONTINUE
}		
public OyuncuOlunce(victim, attacker, shouldgib) {
	if(g_HasBow[victim]) {
		g_HasBow[victim] = false
		fm_set_rendering(victim,_,0,0,0,_,0); 

		message_begin(MSG_ONE, g_msgBarTime, _, victim)
		write_byte(0)
		write_byte(0) 
		message_end()
		
		remowegun(victim)
	}
	katil[victim]=attacker
	new isim[32], isim2[32]
	get_user_name(victim, isim, charsmax(isim));
	get_user_name(attacker, isim2, charsmax(isim2));

	if(is_user_connected(attacker)) {
		ColorChat(victim,NORMAL,"%s Seni olduren ^4%s^1 oldugunde sen yeniden dogacaksin.", tag, isim2);
	}
	new oyuncular[32], oyunculistesi,ceset;
	get_players(oyuncular, oyunculistesi,"b");

	for(new id;id<oyunculistesi;id++) {
		ceset = oyuncular[id];
		if(katil[ceset]==victim && attacker!=ceset) {
			ExecuteHamB(Ham_CS_RoundRespawn, ceset);
			katil[ceset]=0;
			ColorChat(ceset,NORMAL,"%s Katilin ^4%s^1 oldugu icin ^4Yeniden Dogdun^1.!", tag, isim);
		}
	}
	return PLUGIN_HANDLED;
}
public give_bow(id) {
	give_weapon(id)
	g_bow_mode[id] = NORMAL_MODE

	g_normal_ammo[id] = NORMAL_AMMO
}
public give_bow2(id) {
	give_weapon(id)
	g_bow_mode[id] = NORMAL_MODE

	g_normal_ammo[id] = NORMAL_AMMO
	g_fire_ammo[id] = FIRE_AMMO
}
public give_bow3(id) {
	give_weapon(id)
	g_bow_mode[id] = NORMAL_MODE

	g_normal_ammo[id] = NORMAL_AMMO
	g_fire_ammo[id] = FIRE_AMMO
	g_ice_ammo[id] = ICE_AMMO
}
public give_bow4(id) {
	give_weapon(id)
	g_bow_mode[id] = NORMAL_MODE

	g_normal_ammo[id] = NORMAL_AMMO
	g_fire_ammo[id] = FIRE_AMMO
	g_ice_ammo[id] = ICE_AMMO
	g_poison_ammo[id] = POISON_AMMO
}
public give_bow5(id) {
	give_weapon(id)
	g_bow_mode[id] = NORMAL_MODE

	g_normal_ammo[id] = NORMAL_AMMO
	g_fire_ammo[id] = FIRE_AMMO
	g_ice_ammo[id] = ICE_AMMO
	g_poison_ammo[id] = POISON_AMMO
	g_explode_ammo[id] = EXPLODE_AMMO
}
public pfn_keyvalue(Entity) { 
	new ClassName[20], Dummy[2];
	copy_keyvalue(ClassName, charsmax(ClassName), Dummy, charsmax(Dummy), Dummy, charsmax(Dummy));
	
	if(equal(ClassName, "info_map_parameters")) { 
		remove_entity(Entity);
		return PLUGIN_HANDLED ;
	} 
	return PLUGIN_CONTINUE;
}
public give_weapon(id){
	g_HasBow[id] = true
	fm_give_item(id,"weapon_scout")
	update_ammo(id)
}
public fw_bow_PrimaryAttack(Weapon) {
	new Player = get_pdata_cbase(Weapon, 41, 4)
	
	if (g_HasBow[Player])
	return HAM_SUPERCEDE

	return HAM_IGNORED
}
public fw_bow_SecondaryAttack(Weapon) {
	new Player = get_pdata_cbase(Weapon, 41, 4)
	
	if (g_HasBow[Player])
	return HAM_SUPERCEDE

	return HAM_IGNORED
}
public fw_bow_Reload(Weapon) {
     	new Player = get_pdata_cbase(Weapon, 41, 4)
	
	if (g_HasBow[Player])
	return HAM_SUPERCEDE

	return HAM_IGNORED
}
public fw_bow_Deploy_Post(Weapon) {
	new Player = get_pdata_cbase(Weapon, 41, 4)
	
	update_ammo(Player)
}
public fw_CmdStart(id, uc_handle, seed) {
	if(!g_HasBow[id])
		return FMRES_IGNORED

	static CurButton, OldButton
	
	CurButton = get_uc(uc_handle, UC_Buttons)
	OldButton = (pev(id, pev_oldbuttons) & IN_ATTACK)
	
	if(get_gametime() - g_finish_time[id] > NEXT_SHOT_TIME) {
		if(CurButton & IN_ATTACK && !OldButton) {
			if(get_user_weapon(id) != CSW_SCOUT)
				return FMRES_IGNORED

			if((g_bow_mode[id] == NORMAL_MODE && g_normal_ammo[id] <= 0) || (g_bow_mode[id] == FIRE_MODE && g_fire_ammo[id] <= 0) || (g_bow_mode[id] == ICE_MODE && g_ice_ammo[id] <= 0) || (g_bow_mode[id] == POISON_MODE && g_poison_ammo[id] <= 0) || (g_bow_mode[id] == EXPLODE_MODE && g_explode_ammo[id] <= 0))
				return FMRES_IGNORED

			g_start_time[id] = get_gametime()

			// A bar appears in his screen
			message_begin(MSG_ONE_UNRELIABLE, g_msgBarTime, _, id)
			write_byte(3) // time
			write_byte(0) // unknown
			message_end()

			g_pressed[id] = true
		}

		if(CurButton & IN_ATTACK && OldButton) {
			if((g_bow_mode[id] == NORMAL_MODE && g_normal_ammo[id] <= 0) || (g_bow_mode[id] == FIRE_MODE && g_fire_ammo[id] <= 0) || (g_bow_mode[id] == ICE_MODE && g_ice_ammo[id] <= 0) || (g_bow_mode[id] == POISON_MODE && g_poison_ammo[id] <= 0) || (g_bow_mode[id] == EXPLODE_MODE && g_explode_ammo[id] <= 0))
				return FMRES_IGNORED

			if(!g_pressed[id])
				return FMRES_IGNORED
		
			if(get_user_weapon(id) != CSW_SCOUT) {
				g_finish_time[id] = get_gametime()
		
				FireArrow(id)

				// Remove screen's bar
				message_begin(MSG_ONE, g_msgBarTime, _, id)
				write_byte(0) // time
				write_byte(0) // unknown
				message_end()

				g_pressed[id] = false
			}
		}
		if(!(CurButton & IN_ATTACK) && OldButton) {			
			if(get_user_weapon(id) != CSW_SCOUT)
				return FMRES_IGNORED

			if((g_bow_mode[id] == NORMAL_MODE && g_normal_ammo[id] <= 0) || (g_bow_mode[id] == FIRE_MODE && g_fire_ammo[id] <= 0) || (g_bow_mode[id] == ICE_MODE && g_ice_ammo[id] <= 0) || (g_bow_mode[id] == POISON_MODE && g_poison_ammo[id] <= 0) || (g_bow_mode[id] == EXPLODE_MODE && g_explode_ammo[id] <= 0))
				return FMRES_IGNORED

			if(!g_pressed[id])
				return FMRES_IGNORED

			g_finish_time[id] = get_gametime()
		
			FireArrow(id)

			message_begin(MSG_ONE, g_msgBarTime, _, id)
			write_byte(0) 
			write_byte(0) 
			message_end()

			g_pressed[id] = false
		}
	}
	if((CurButton & IN_ATTACK2) && !(pev(id, pev_oldbuttons) & IN_ATTACK2)) {		
		if(get_user_weapon(id) != CSW_SCOUT)
			return FMRES_IGNORED

		if(!g_pressed[id]) {
			cmdMenu(id)
		}
	}	
	return FMRES_HANDLED
}
public fw_UpdateClientData_Post(id, sendweapons, cd_handle) {	
	if (!is_user_alive(id)) 
	return FMRES_IGNORED

	if(get_user_weapon(id) == CSW_SCOUT && g_HasBow[id]) {
		set_cd(cd_handle, CD_flNextAttack, halflife_time() + 0.001 ); 
	}

	return FMRES_HANDLED
}
public FireArrow(id) {
	playanim(id, anim_shot1)

	new velocity[33]
	new Float:fAngle[3], Float:fVelocity[3]
	pev(id, pev_v_angle, fAngle)
	
	new arrow = create_entity("info_target")
	
	if (!arrow) return PLUGIN_HANDLED

	entity_set_string(arrow, EV_SZ_classname, "bow_arrow")
	
	entity_set_model(arrow, ARROW_MODEL)

	if(g_bow_mode[id] == NORMAL_MODE) {
		fm_set_rendering(arrow, kRenderFxGlowShell, 255, 255, 255, kRenderNormal, 25)
		g_normal_ammo[id]--
	} else if(g_bow_mode[id] == FIRE_MODE) {
		fm_set_rendering(arrow, kRenderFxGlowShell, 255, 0, 0, kRenderNormal, 25)
		g_fire_ammo[id]--
	} else if(g_bow_mode[id] == ICE_MODE) {
		fm_set_rendering(arrow, kRenderFxGlowShell, 0, 0, 255, kRenderNormal, 25)
		g_ice_ammo[id]--
	} else if(g_bow_mode[id] == POISON_MODE) {
		fm_set_rendering(arrow, kRenderFxGlowShell, 0, 255, 0, kRenderNormal, 25)
		g_poison_ammo[id]--
	} else if(g_bow_mode[id] == EXPLODE_MODE) {
		fm_set_rendering(arrow, kRenderFxGlowShell, 150, 105, 0, kRenderNormal, 25)
		g_explode_ammo[id]--
	}

	update_ammo(id)

	new Float:vOrigin[3],Float:vUp[3]
	pev(id, pev_origin, vOrigin)
	
	global_get(glb_v_up, vUp)
	new up = 17
	vOrigin[0] = vOrigin[0] + vUp[0] * up
	vOrigin[1] = vOrigin[1] + vUp[1] * up
	vOrigin[2] = vOrigin[2] + vUp[2] * up
	
	entity_set_origin(arrow, vOrigin)

	entity_set_vector(arrow, EV_VEC_angles, fAngle)
	
	new Float:MinBox[3] = {-1.0, -1.0, -1.0}
	new Float:MaxBox[3] = {1.0, 1.0, 1.0}
	entity_set_vector(arrow, EV_VEC_mins, MinBox)
	entity_set_vector(arrow, EV_VEC_maxs, MaxBox)
	
	entity_set_int(arrow, EV_INT_solid, SOLID_SLIDEBOX)
	
	entity_set_int(arrow, EV_INT_movetype, MOVETYPE_TOSS)
	
	entity_set_edict(arrow, EV_ENT_owner, id)
	
	new Float: holdtime[33] 
	new Float: mnoji[33]

	holdtime[id] = g_finish_time[id] - g_start_time[id]

	if(holdtime[id] < 1.0) holdtime[id] = 1.0
	if(holdtime[id] > 3.0) holdtime[id] = 3.0

	
	mnoji[id] = BASE_SPEED + holdtime[id] * BONUS_SPEED
	velocity[id] = floatround(mnoji[id],floatround_round)
	VelocityByAim(id, velocity[id], fVelocity)
	
	entity_set_vector(arrow, EV_VEC_velocity, fVelocity)

	emit_sound(arrow, CHAN_WEAPON, ARROW_SHOOT, VOL_NORM, ATTN_NORM, 0, PITCH_NORM)

	return PLUGIN_CONTINUE
}	
public pfn_touch(ptr, ptd) {
	if(pev_valid(ptr)) {	
		static classname[32], classnameptd[32]
		pev(ptr, pev_classname, classname, 31)
		
		if(equal(classname, "bow_arrow")) {
			new Float:Origin[3]
			pev(ptr, pev_origin, Origin)

			new owner = pev(ptr, pev_owner)

			if(g_bow_mode[owner] == EXPLODE_MODE) {
				engfunc(EngFunc_MessageBegin, MSG_PVS, SVC_TEMPENTITY, Origin, 0)
				write_byte(TE_EXPLOSION)
				engfunc(EngFunc_WriteCoord, Origin[0])
				engfunc(EngFunc_WriteCoord, Origin[1])
				engfunc(EngFunc_WriteCoord, Origin[2])
				write_short(g_exp_sprid)
				write_byte(40)
				write_byte(30)
				write_byte(0)
				message_end()

				check_radius_damage(ptr, owner)
			}
			if(is_user_alive(ptd)) {
				if(get_user_team(ptd) != get_user_team(owner)) {
					g_old_speed[ptd] = fm_get_user_maxspeed(ptd)

					if(g_bow_mode[owner] == NORMAL_MODE) {
						ExecuteHamB(Ham_TakeDamage, ptd, ptr, owner, NORMAL_DMG, DMG_BULLET)
					} else if(g_bow_mode[owner] == FIRE_MODE) {
						g_dmg_mode[ptd] = dmg_fire
						CreateBurn(ptd, owner)
					} else if(g_bow_mode[owner] == ICE_MODE) {
						if(!g_slowed[ptd] && !g_Burn[ptd]) {
							g_FrozenRenderingFx[ptd] = pev(ptd, pev_renderfx)
							pev(ptd, pev_rendercolor, g_FrozenRenderingColor[ptd])
							g_FrozenRenderingRender[ptd] = pev(ptd, pev_rendermode)
							pev(ptd, pev_renderamt, g_FrozenRenderingAmount[ptd])

							fm_set_rendering(ptd, kRenderFxGlowShell, 0, 100, 200, kRenderNormal, 25)
							fm_set_user_maxspeed(ptd, fm_get_user_maxspeed(ptd) * SPEED_LOW_ICE)
							g_slowed[ptd] = true
							set_task(SLOW_ICE_TIME, "make_speed", ptd, _, _, "a", 1)
				
							message_begin(MSG_ONE_UNRELIABLE, g_MsgDamage, _, ptd)
							write_byte(0) // damage save
							write_byte(0) // damage take
							write_long(DMG_DROWN) // damage type - DMG_FREEZE
							write_coord(0) // x
							write_coord(0) // y
							write_coord(0) // z
							message_end()
						}
					} else if(g_bow_mode[owner] == POISON_MODE) {
						if(!g_slowed[ptd]) {
							fm_set_user_maxspeed(ptd, fm_get_user_maxspeed(ptd) * SPEED_LOW_POISON)
							g_slowed[ptd] = true
							set_task(SLOW_POISON_TIME, "make_speed", ptd, _, _, "a", 1)

							g_dmg_mode[ptd] = dmg_poison
							CreateBurn(ptd, owner)
						}
					}
				}
			}
			if(pev_valid(ptd)) {
				pev(ptd, pev_classname, classnameptd, 31)
				if(equali(classnameptd, "func_breakable")) {
					force_use(ptr,ptd)
				}
			}
			set_pev(ptr, pev_flags, FL_KILLME)
		}
	}	
	if(is_valid_ent(ptr)) {
		new classname[32]
		entity_get_string(ptr,EV_SZ_classname,classname,31)
		
		if(equal(classname, "bow")) {
			if(is_valid_ent(ptd)) {
				new id = ptd
				if(id > 0 && id < 34) {
					if(allowed_toucher(id)) {
						give_weapon(id)
						remove_entity(ptr)
					}
				}
			}
		}
	}
}
public CreateBurn(id, attacker) {
	if(g_Burn[id] || g_Poisoned[id])
		return

	if(g_dmg_mode[id] == dmg_fire) {
		new ent=CreateAnimationSprite(attacker, BURN_CLASSNAME, BURN_MODEL, 1.0, 10.0)
	
		set_pev(ent, pev_solid, SOLID_NOT)
		set_pev(ent, pev_movetype, MOVETYPE_FOLLOW)
	
		set_pev(ent, pev_aiment, id)
	
		set_pev(ent, pev_fuser2, get_gametime()+BURN_LIFE)
	
		g_Burn[id]=get_gametime()+BURN_PERIOD
	}
	if(g_dmg_mode[id] == dmg_poison) {
		new ent=CreateAnimationSprite(attacker, BURN_CLASSNAME, POISON_MODEL, 1.0, 10.0)
	
		set_pev(ent, pev_solid, SOLID_NOT)
		set_pev(ent, pev_movetype, MOVETYPE_FOLLOW)
	
		set_pev(ent, pev_aiment, id)
	
		set_pev(ent, pev_fuser2, get_gametime()+POISON_TIME)
	
		g_Poisoned[id]=get_gametime()+POISON_PERIOD
	}
}
public BurnThink(ent) {
	if(!pev_valid(ent))
		return
		
	static Float:life, aim_ent
	
	pev(ent,pev_fuser2, life)
	
	aim_ent=pev(ent, pev_aiment)

	if(g_dmg_mode[aim_ent] == dmg_fire) {	
		if(get_gametime()>life||!is_user_alive(aim_ent)) {
			g_Burn[aim_ent]=0.0	
		
			fm_remove_entity(ent)
		
			return
		}
		if(get_gametime()>g_Burn[aim_ent]) {
			ExecuteHamB(Ham_TakeDamage, aim_ent , ent ,pev(ent, pev_owner), BURN_DAMAGE, DMG_BURN)
		
			g_Burn[aim_ent]=get_gametime()+BURN_PERIOD
		}
	}
	if(g_dmg_mode[aim_ent] == dmg_poison) {
		if(get_gametime()>life||!is_user_alive(aim_ent)) {
			g_Poisoned[aim_ent]=0.0	
		
			fm_remove_entity(ent)
		
			return
		}
		if(get_gametime()>g_Poisoned[aim_ent]) {
			ExecuteHamB(Ham_TakeDamage, aim_ent , ent ,pev(ent, pev_owner), POISON_DAMAGE, DMG_ACID)
		
			g_Poisoned[aim_ent]=get_gametime()+POISON_PERIOD
		}
	}
}
public make_speed(id) {
	if(is_user_alive(id) && g_slowed[id]) {
		g_slowed[id] = false
		fm_set_user_maxspeed(id, g_old_speed[id])
		fm_set_rendering_float(id, g_FrozenRenderingFx[id], g_FrozenRenderingColor[id], g_FrozenRenderingRender[id], g_FrozenRenderingAmount[id])
	}
}
public check_radius_damage(ent, attacker) {
	for(new id = 0; id < g_MaxPlayers; id++) {
		if(!is_user_alive(id))
			continue
		if(get_user_team(attacker) == get_user_team(id))
			continue
		if(entity_range(ent, id) > EXPLODE_HITRADIUS)
			continue
			
		Do_TakeDamage(ent, id, attacker, can_see_fm(ent, id))
	}
}
public Do_TakeDamage(Ent, Victim, Attacker, can_see) {
	static Float:Damage, Float:CurrentDis
	
	CurrentDis = entity_range(Ent, Victim)
	Damage = EXPLODE_DAMAGE - ((CurrentDis / EXPLODE_HITRADIUS) * EXPLODE_DAMAGE)
	
	if(Damage > 0) {
		static WeaponEnt
		WeaponEnt = fm_get_user_weapon_entity(Attacker, CSW_HEGRENADE)
		
		if(!pev_valid(WeaponEnt))
			WeaponEnt = 0

		if(!can_see)
			Damage /= 2
			
		ExecuteHamB(Ham_TakeDamage, Victim, WeaponEnt, Attacker, Damage, DMG_BULLET)
	}	
}
public update_ammo(id) {
	if(!is_user_alive(id))
		return;

	if(g_bow_mode[id] == NORMAL_MODE) {
		g_ammo[id] = g_normal_ammo[id];
	} else if(g_bow_mode[id] == FIRE_MODE) {
		g_ammo[id] = g_fire_ammo[id];
	} else if(g_bow_mode[id] == ICE_MODE) {
		g_ammo[id] = g_ice_ammo[id];
	} else if(g_bow_mode[id] == POISON_MODE) {
		g_ammo[id] = g_poison_ammo[id];
	} else if(g_bow_mode[id] == EXPLODE_MODE) {
		g_ammo[id] = g_explode_ammo[id];
	}
	
	static weapon_ent; weapon_ent = fm_find_ent_by_owner(-1, "weapon_scout", id);
	if(pev_valid(weapon_ent)) fm_cs_set_weapon_ammo(weapon_ent, 1);	
	
	fm_cs_set_user_bpammo(id, CSW_SCOUT, g_ammo[id]);
	
	engfunc(EngFunc_MessageBegin, MSG_ONE_UNRELIABLE, get_user_msgid("CurWeapon"), {0, 0, 0}, id);
	write_byte(1);
	write_byte(CSW_SCOUT);
	write_byte(-1);
	message_end();

	set_task(0.1, "hud_debug", id);
}
public hud_debug(id) {
	engfunc(EngFunc_MessageBegin, MSG_ONE_UNRELIABLE, get_user_msgid("CurWeapon"), {0, 0, 0}, id)
	write_byte(1)
	write_byte(CSW_SCOUT)
	write_byte(-1)
	message_end()
}
public can_see_fm(entindex1, entindex2) {
	if (!entindex1 || !entindex2)
		return false

	if (pev_valid(entindex1) && pev_valid(entindex1)) {
		new flags = pev(entindex1, pev_flags)
		if (flags & EF_NODRAW || flags & FL_NOTARGET) {
			return 0
		}

		new Float:lookerOrig[3]
		new Float:targetBaseOrig[3]
		new Float:targetOrig[3]
		new Float:temp[3]

		pev(entindex1, pev_origin, lookerOrig)
		pev(entindex1, pev_view_ofs, temp)
		lookerOrig[0] += temp[0]
		lookerOrig[1] += temp[1]
		lookerOrig[2] += temp[2]

		pev(entindex2, pev_origin, targetBaseOrig)
		pev(entindex2, pev_view_ofs, temp)
		targetOrig[0] = targetBaseOrig [0] + temp[0]
		targetOrig[1] = targetBaseOrig [1] + temp[1]
		targetOrig[2] = targetBaseOrig [2] + temp[2]

		engfunc(EngFunc_TraceLine, lookerOrig, targetOrig, 0, entindex1, 0) //  checks the had of seen player
		if(get_tr2(0, TraceResult:TR_InOpen) && get_tr2(0, TraceResult:TR_InWater)) {
			return 0
		} else {
			new Float:flFraction
			get_tr2(0, TraceResult:TR_flFraction, flFraction)
			if(flFraction == 1.0 || (get_tr2(0, TraceResult:TR_pHit) == entindex2)) {
				return 1
			} else {
				targetOrig[0] = targetBaseOrig [0]
				targetOrig[1] = targetBaseOrig [1]
				targetOrig[2] = targetBaseOrig [2]
				engfunc(EngFunc_TraceLine, lookerOrig, targetOrig, 0, entindex1, 0) //  checks the body of seen player
				get_tr2(0, TraceResult:TR_flFraction, flFraction)
				if(flFraction == 1.0 || (get_tr2(0, TraceResult:TR_pHit) == entindex2)) {
					return 1
				} else {
					targetOrig[0] = targetBaseOrig [0]
					targetOrig[1] = targetBaseOrig [1]
					targetOrig[2] = targetBaseOrig [2] - 17.0
					engfunc(EngFunc_TraceLine, lookerOrig, targetOrig, 0, entindex1, 0) //  checks the legs of seen player
					get_tr2(0, TraceResult:TR_flFraction, flFraction)
					if(flFraction == 1.0 || (get_tr2(0, TraceResult:TR_pHit) == entindex2)) {
						return 1
					}
				}
			}
		}
	}
	return 0
}
public SaveData(id) {
	new AuthID[35]
	get_user_authid(id,AuthID,charsmax(AuthID))
	new vaultkey[64],vaultdata[256]

	format(vaultkey,charsmax(vaultkey),"%s-Mod", AuthID)
	format(vaultdata,charsmax(vaultdata),"%i#%i#",g_exp[id],g_level[id])

	nvault_set(g_vault,vaultkey,vaultdata)
	return PLUGIN_CONTINUE
}
public LoadData(id) {
	new AuthID[35]
	get_user_authid(id,AuthID,charsmax(AuthID))
	new vaultkey[64],vaultdata[256]

	format(vaultkey,charsmax(vaultkey),"%s-Mod",AuthID)
	format(vaultdata,charsmax(vaultdata),"%i#%i#",g_exp[id],g_level[id])

	nvault_get(g_vault,vaultkey,vaultdata,255)
	replace_all(vaultdata, 255, "#", " ")
	new playerxp[32], playerlevel[32]
	parse(vaultdata, playerxp, charsmax(playerxp), playerlevel, charsmax(playerlevel))
	g_exp[id] = str_to_num(playerxp)
	g_level[id] = str_to_num(playerlevel)

	return PLUGIN_CONTINUE
}
stock allowed_toucher(player) {
	if (g_HasBow[player])
		return false
	
	return true
}
stock print(const id, const input[], any:...) {
	new iCount = 1, iPlayers[32]
    
	static szMsg[191]
	vformat(szMsg, charsmax(szMsg), input, 3)
    
	replace_all(szMsg, 190, "^x04", "^4") // green txt
	replace_all(szMsg, 190, "^x01", "^1") // orange txt
	replace_all(szMsg, 190, "^x03", "^3") // team txt
	replace_all(szMsg, 190, "^x00", "^0") // team txt
    
	if(id) iPlayers[0] = id
	else get_players(iPlayers, iCount, "ch")
        
	for (new i = 0; i < iCount; i++) {
		if (is_user_connected(iPlayers[i])) {
			message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("SayText"), _, iPlayers[i])
			write_byte(iPlayers[i])
			write_string(szMsg)
			message_end()
		}
	}
}  
stock CreateAnimationSprite(owner, const classname[], const model[], Float:scale, Float:framerate) {
	new ent=fm_create_entity("env_sprite")

	set_pev(ent, pev_framerate, framerate)
	set_pev(ent, pev_model, model)

	dllfunc(DLLFunc_Spawn, ent)

	set_pev(ent, pev_classname, classname)
	set_pev(ent, pev_owner, owner)

	fm_entity_set_model(ent, model)
	fm_set_rendering(ent, kRenderFxNoDissipation, 255, 255, 255, kRenderGlow, 255)

	set_pev(ent, pev_framerate, framerate)
	set_pev(ent, pev_scale, scale)

	return ent
}
stock fm_set_rendering_float(entity, fx = kRenderFxNone, Float:color[3], render = kRenderNormal, Float:amount = 16.0) {
	set_pev(entity, pev_renderfx, fx)
	set_pev(entity, pev_rendercolor, color)
	set_pev(entity, pev_rendermode, render)
	set_pev(entity, pev_renderamt, amount)
}
stock fm_set_user_maxspeed(index, Float:speed = -1.0) {
	engfunc(EngFunc_SetClientMaxspeed, index, speed);
	set_pev(index, pev_maxspeed, speed);

	return 1;
}
stock Float:fm_get_user_maxspeed(index) {
	new Float:speed;
	pev(index, pev_maxspeed, speed);

	return speed;
}
stock fm_set_rendering(entity, fx = kRenderFxNone, r = 255, g = 255, b = 255, render = kRenderNormal, amount = 16) { 
	new Float:RenderColor[3]; 
	RenderColor[0] = float(r); 
	RenderColor[1] = float(g); 
	RenderColor[2] = float(b); 

	set_pev(entity, pev_renderfx, fx); 
	set_pev(entity, pev_rendercolor, RenderColor); 
	set_pev(entity, pev_rendermode, render); 
	set_pev(entity, pev_renderamt, float(amount)); 

	return 1; 
}
stock bool:fm_strip_user_gun(index, wid = 0, const wname[] = "") {
	new ent_class[32];
	if (!wid && wname[0])
		copy(ent_class, sizeof ent_class - 1, wname);
	else {
		new weapon = wid, clip, ammo;
		if (!weapon && !(weapon = get_user_weapon(index, clip, ammo)))
			return false;
		
		get_weaponname(weapon, ent_class, sizeof ent_class - 1);
	}

	new ent_weap = fm_find_ent_by_owner(-1, ent_class, index);
	if (!ent_weap)
		return false;

	engclient_cmd(index, "drop", ent_class);

	new ent_box = pev(ent_weap, pev_owner);
	if (!ent_box || ent_box == index)
		return false;

	dllfunc(DLLFunc_Think, ent_box);

	return true;
}
stock fm_strip_user_weapons(index) {
	new ent = fm_create_entity("player_weaponstrip");
	if (!pev_valid(ent))
		return 0;

	dllfunc(DLLFunc_Spawn, ent);
	dllfunc(DLLFunc_Use, ent, index);
	engfunc(EngFunc_RemoveEntity, ent);

	return 1;
}
stock fm_set_user_health(index, health) {
	health > 0 ? set_pev(index, pev_health, float(health)) : dllfunc(DLLFunc_ClientKill, index);

	return 1;
}
stock fm_get_user_weapon_entity(id, wid = 0) {
	new weap = wid, clip, ammo;
	if (!weap && !(weap = get_user_weapon(id, clip, ammo)))
		return 0;
	
	new class[32];
	get_weaponname(weap, class, sizeof class - 1);

	return fm_find_ent_by_owner(-1, class, id);
}
stock fm_find_ent_by_owner(index, const classname[], owner, jghgtype = 0) {
	new strtype[11] = "classname", ent = index;
	switch (jghgtype) {
		case 1: strtype = "target";
		case 2: strtype = "targetname";
	}

	while ((ent = engfunc(EngFunc_FindEntityByString, ent, strtype, classname)) && pev(ent, pev_owner) != owner) {}

	return ent;
}
stock player_in_list(id) {
	new s_Name[32], s_AuthID[32]
	get_user_name (id,s_Name,31)
	get_user_authid(id,s_AuthID,31)
	
	for(new i; i<ToplamSatir; i++ ) {
		if (!strcmp(s_Name,OyuncuListesi[i]))
			return 1
		if (!strcmp(s_AuthID,OyuncuListesi[i]))
			return 1
	}
	return 0
}
stock fm_give_item(index, const item[]) {
	if (!equal(item, "weapon_", 7) && !equal(item, "ammo_", 5) && !equal(item, "item_", 5) && !equal(item, "tf_weapon_", 10))
		return 0;

	new ent = fm_create_entity(item);
	if (!pev_valid(ent))
		return 0;

	new Float:origin[3];
	pev(index, pev_origin, origin);
	set_pev(ent, pev_origin, origin);
	set_pev(ent, pev_spawnflags, pev(ent, pev_spawnflags) | SF_NORESPAWN);
	dllfunc(DLLFunc_Spawn, ent);

	new save = pev(ent, pev_solid);
	dllfunc(DLLFunc_Touch, ent, index);
	if (pev(ent, pev_solid) != save)
		return ent;

	engfunc(EngFunc_RemoveEntity, ent);

	return -1;
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1055\\ f0\\ fs16 \n\\ par }
*/
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ ansicpg1254\\ deff0\\ deflang1055{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ f0\\ fs16 \n\\ par }
*/
